 ## -*- texinfo -*-
## @deftypefn  {Function File} {} dboutput =  db(@var{x})
## @deftypefnx {Function File} {} dboutput =  db(@var{x},SignalType)
## @deftypefnx {Function File} {} dboutput =  db(@var{x},@var{R})
## @deftypefnx  {Function File} {} dboutput =  db(@var{x},'voltage',@var{R})
## @end deftypefn


function dboutput = db(x,varargin)

  if ((nargin<1 || nargin>3))
    print_usage;
  endif

   if ~DataValidation (x)
    error('x must be scalar, vector, matrix or N-D array');
  endif
  % defual value of resistance
  R=1;
  if(nargin>1)
  % The text option must be power of voltage

  if ((ischar(varargin{1}) || nargin==3) &&( ~strcmp(tolower(varargin{1}),'power' )&& ~strcmp(tolower(varargin{1}),'voltage')))
     print_usage;
   endif

   if(strcmp(tolower(varargin{1}),'power'))

      if(any(x<0))
       error('For ''power'',x must be positive');
     else
       dboutput = 10*log10(x);
      end

   else

      if (nargin==3)
         R=varargin{2};
      elseif (isnumeric(varargin{1}))
        R=varargin{1};
      endif
      if(~isnumeric(R) || ~isscalar(R) || R<0)
       error('R must be positive and scalar');
     else
       dboutput = 10*log10(x.^2/R);
       endif



endif

else
dboutput = 10*log10(x.^2);
endif


endfunction

 function check = DataValidation (x)


  check  = ((isnumeric (x) || isinteger (x) || isfloat(x)) && !isempty (x));
endfunction
