 ## -*- texinfo -*-
## @deftypefn  {Function File} {} [@var{yupper},@var{ylower}] =  envelope(@var{x})
## @deftypefnx {Function File} {} [@var{yupper},@var{ylower}] =  envelope(@var{x},@var{f1},'analytic')
## @deftypefnx {Function File} {} [@var{yupper},@var{ylower}] =  envelope(@var{x},@var{w1},'rms')
## @deftypefnx  {Function File} {} [@var{yupper},@var{ylower}] =  envelope(@var{x},@var{np},'peak')
## @deftypefnx  {Function File} {}  envelope(@dots{})
## @end deftypefn


function varargout = envelope(x,varargin)

if (nargin<1 || nargin>3 || nargout>2 || nargout==1)
    print_usage;
  endif
if (nargin>1)
    error('currently, [yupper,ylower] = envelope(x) is available');
  endif

  if ~DataValidation (x)
    error('x must be single or double');
  endif

  if ~isreal(x)
    warning ('envelope: ignoring imaginary part of signal');
    x = real (x);
  endif

  % number of the data point
  if (any(size(x)==1))
    n=length(x);
  else
    n=size(x,1);
  end
  % Mean value
    m=mean(x);
    z=abs(hilbert(x-m));
    yupper=z+m;
    ylower=-z+m;

    if(nargout==0)
    env = abs(z);

   plot(x)
   hold on
   plot(yupper,'Color', [0.5 0.0 0.2])
   plot( ylower,'Color', [0.5 0.0 0.2])
   hold off
   title('Envelope')
   else
   varargout{1}=yupper;
   varargout{2}=ylower;
    endif


endfunction

%%-------------------------------------



  function check = DataValidation (x)

  %Types={'single ',' double '};

  check  = ((isnumeric (x) || isinteger (x) || isfloat(x)) && !isempty (x));
endfunction
